<?php
/*                                                       */
/* finances2.php - Financial overview of billsbook       */
/* $ID 187c2 - 2024-01-06 - brom $                       */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2015  (kontakt@brom-belcal.de)    */
/*                                                       */

if(!defined('BC_PATH')){ exit("Cannot access this file directly"); }
require_once(BC_PATH.'/lib/winopen.inc.php');
require_once(BC_PATH.'/modules/calendar/calc_functions.php');
$detaillist = false;
$bilbook = false;
$newbilcolornote = '';
$output = '';
$csv_output = '';
$csv_seperator = ';';
$csv_seperator2 = '"';
$user_id = $admin->get_user_id();
if(isset($_GET['bilbook']) AND is_numeric($_GET['bilbook'])){ $bilbook = true; }
$actionurl = ADMIN_URL.'/finances/index.php?bilbook=1';
$queryfields = '';
// Include the PopUp-Calendar if availlable
if(file_exists(BC_PATH.'/lib/include/jscalendar/jscal-setup.php')){
  require_once(BC_PATH.'/lib/functions.php');
  $jscal_use_time = false; // whether to use a clock, too
  $jscal_type = 'backend';
  $holiday = get_holi_jsdays();
  require(BC_PATH.'/lib/include/jscalendar/jscal-setup.php');
  // output the jscalendar include links befor other outputs
  if(BC_VERSION < 3.35){
    echo $jscal_loadlinks;
  }
}
// First check the field canceled from res files
$iscanceled = false;
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_files`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='canceled'){ $iscanceled = true; }
}
if($iscanceled == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_files` ADD `canceled` TINYINT(1) NOT NULL AFTER `savedate`");
}
// Check first we more then one bills for reservation or not canceled bil before storno
$get_bills = $datapdo->query("SELECT `res_id`,`rfile_id` FROM `".TABLE_PREFIX."res_files` WHERE `tpl`='5' ORDER BY `res_id`ASC, `rfile_id` ASC");
if($datapdo->numRows($get_bills)>0){
  while($res = $datapdo->fetchRow($get_bills)){
    $resid = $res['res_id'];
    $rfid = $res['rfile_id'];
    $datapdo->query("UPDATE `".TABLE_PREFIX."res_files` SET `canceled`='1' WHERE `res_id`='$resid' AND `tpl`='3' AND `rfile_id`<'$rfid'");
  }
}
$get_bills = $datapdo->query("SELECT `res_id`,`rfile_id` FROM `".TABLE_PREFIX."res_files` WHERE `tpl`='3' AND `canceled`='0' ORDER BY `res_id` ASC, `rfile_id` DESC");
$m_resid = 0;
if($datapdo->numRows($get_bills)>1){
  while($res = $datapdo->fetchRow($get_bills)){
    $resid = $res['res_id'];
    $rfid = $res['rfile_id'];
    $datapdo->query("UPDATE `".TABLE_PREFIX."res_files` SET `canceled`='1' WHERE `res_id`='$resid' AND `tpl`='3' AND `rfile_id`<'$rfid'");
  }
}
$is_resbilling = false;
if($datapdo->numRows($datapdo->query("SHOW TABLES LIKE '".TABLE_PREFIX."resbilling_obj%'"))>0){
  // Check the objectset is configured
  if($datapdo->numRows($datapdo->query("SELECT `bilobjset_id` FROM `".TABLE_PREFIX."resbilling_objset`"))>0){
    $is_resbilling = true;
  }
}
if(!isset($_SESSION['datefilter'])){
  $_SESSION['datefilter']=array('start'=>'','end'=>'');
  $currmonth = date('n',time());
  $curryear = date('Y',time());
  switch ($currmonth){
    case 12:
    case 11:
    case 10:
      $lastquarterdatestart = date('d.m.Y',mktime(12,0,0,7,1,$curryear));
      $lastquarterdateend = date('d.m.Y',mktime(12,0,0,9,30,$curryear));
      break;
    case 9:
    case 8:
    case 7:
      $lastquarterdatestart = date('d.m.Y',mktime(12,0,0,4,1,$curryear));
      $lastquarterdateend = date('d.m.Y',mktime(12,0,0,6,30,$curryear));
      break;
    case 6:
    case 5:
    case 4:
      $lastquarterdatestart = date('d.m.Y',mktime(12,0,0,1,1,$curryear));
      $lastquarterdateend = date('d.m.Y',mktime(12,0,0,3,31,$curryear));
      break;
    case 3:
    case 2:
    case 1:
      $lastquarterdatestart = date('d.m.Y',mktime(12,0,0,10,1,$curryear-1));
      $lastquarterdateend = date('d.m.Y',mktime(12,0,0,12,31,$curryear-1));
      break;
  }
  $_SESSION['datefilter']['start']=$lastquarterdatestart;
  $_SESSION['datefilter']['end']=$lastquarterdateend;
  $show_rg = true;
  $show_prov = $is_resbilling;
  $_SESSION['datefilter']['show_rglist']=($show_prov == true?1:2);
}
include(ADMIN_PATH.'/reservations/datefilter.php');

$objects = array();
// Include the check of filter is set
$get_all_objects = $datapdo->query("SELECT s.`object_id`,o.`admin_users`,s.`section_id` FROM `".TABLE_PREFIX."sections` AS s,`".TABLE_PREFIX."objects` AS o WHERE  s.`module`='calendar' AND o.`visibility`!='deleted' AND o.`object_id`=s.`object_id` ORDER BY o.`level`,o.`position` ASC");
if($datapdo->is_error()){ echo $datapdo->get_error(); }
if($datapdo->numRows($get_all_objects)>0){
  while($all_objects = $datapdo->fetchRow($get_all_objects)){
    $all_admin_users = explode(',', $all_objects['admin_users']);
    if(!is_numeric(array_search($admin->get_user_id(), $all_admin_users))){ continue; }
    $chkiscalculator = $datapdo->get_one("SELECT `calculator` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='".$all_objects['object_id']."' LIMIT 1");
    if($chkiscalculator == 1){
      $display_paymentcontrol = $datapdo->get_one("SELECT `paycontrol` FROM `".TABLE_PREFIX."res_paymentset` WHERE `object_id`='".$all_objects['object_id']."' LIMIT 1");
      if($display_paymentcontrol == 1){ $havepaycontrol = true; }
    // if(isset($_SESSION['filter']['onlypayment']) AND $_SESSION['filter']['onlypayment']==1 AND $display_paymentcontrol == 0){ continue; }
    // Get the calendar this object
    // $get_calendar = $datapdo->query("SELECT `object_id`,`section_id` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='".$all_objects['object_id']."' LIMIT 1");
    // if($datapdo->numRows($get_calendar)>0){
    //  $calendar = $datapdo->fetchRow($get_calendar);
        $cal_objects[$all_objects['object_id']] = $all_objects['section_id'];
        array_push($objects,$all_objects['object_id']);
      }
    // }
  }
  if(count($cal_objects) == 0){
    $admin->print_error($MESSAGE['OBJECTS']['NOT_FOUND'],ADMIN_URL.'/objects/index.php');
  }
  if(count($cal_objects) == 1){ $DISPLAY_SORT = 'none'; }
}
else{
  $admin->print_error($MESSAGE['OBJECTS']['NOT_FOUND'],ADMIN_URL.'/objects/index.php');
}
// Check all selected objects ar in list

if(isset($_SESSION['datefilter']['objects'])){
  foreach($_SESSION['datefilter']['objects'] AS $oK => $oV){
    if(!array_key_exists($oV,$cal_objects)){ unset($_SESSION['filter']['objects'][$oK]); }
  }
  $obj_filter = implode('|',$_SESSION['datefilter']['objects']);
  $datapdo->query("UPDATE `".TABLE_PREFIX."users` SET `obj_filter`='$obj_filter' WHERE `user_id`='$user_id' LIMIT 1");
  $objects = array();
  foreach($_SESSION['datefilter']['objects'] AS $oK => $oV){ array_push($objects,$oV); }
}
else{
  if(count($cal_objects)<10){
    foreach($cal_objects AS $oK => $oV){ array_push($objects,$oK); }
  }
}
if(count($objects)==0){
  foreach($cal_objects AS $oK => $oV){
    array_push($objects,$oK);
    $_SESSION['datefilter']['objects'] = $objects;
    $obj_filter = implode('|',$_SESSION['filter']['objects']);
    $datapdo->query("UPDATE `".TABLE_PREFIX."users` SET `obj_filter`='$obj_filter' WHERE `user_id`='$user_id' LIMIT 1");
  }
}

include(ADMIN_PATH.'/reservations/datefilterfrm.php');
if(isset($jscal_loaded) AND $jscal_loaded == true){
//  $jscal_include_script = str_replace('cal.hide()','cal.hide();set_new_days()',$jscal_include_script);
  echo $jscal_include_script;
  ?>
  <script type="text/javascript">
    <?php foreach($jscal_dates as $mydate_field){ ?>
	cal.manageFields("trigger_<?php echo $mydate_field; ?>", "<?php echo $mydate_field; ?>", "<?php echo $jscal_ifformat; ?>");
    <?php } ?>
  </script>
<?php
}
$decimal = (LANGUAGE=='EN'?'.':',');
$thousend = (LANGUAGE=='EN'?',':'.');
// Get local charset by language
switch (LANGUAGE){
  case 'CS':
  case 'PL':
    $local_charset = 'ISO-8859-2';
    break;
  case 'ES':
  case 'PT':
    $local_charset = 'ISO-8859-3';
    break;
  case 'DE':
  case 'IT':
  case 'FR':
  case 'EN':
  case 'NL':
  default:
    $local_charset = 'ISO-8859-1';
}
$sum_bruto = 0;
$sum_netto = 0;
$sum_vat = 0;
$sum_paid = 0;
$sum_open = 0;
$sum_paid_bruto = 0;
$sum_paid_vat = 0;
$sum_paid_netto = 0;
$p_unit = '';
$unit = '';
$sales_totalsum = array();
$is_error = false;

if(count($rg_files)>0 AND $show_rg==true){
  $fsql='';
  foreach($rg_files AS $id){ $fsql .= ($fsql!=''?' OR ':'(')."`rfile_id`='".$id."'"; }
  $fsql .=')';
  $fsql .= $dsql.$filter_objsql;
  $rg_output = array();
  $get_allrgfiles = $datapdo->query("SELECT `rfile_id`,`object_id`,`section_id`,`res_id`,`bil_number`,`address_id`,`author`,`title`,`savedate`,`tpl` FROM `".TABLE_PREFIX."res_files` WHERE (`tpl`='3' OR `tpl`='5') AND $fsql ORDER BY `savedate` ASC");
  if($datapdo->numRows($get_allrgfiles)>0){
    while($allrgfiles = $datapdo->fetchRow($get_allrgfiles)){
      $bildetails_array = array();
      $res_id = $allrgfiles['res_id'];
      $is_storno = false;
      if($datapdo->numRows($datapdo->query("SELECT `status` FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$res_id' AND `status`='0' LIMIT 0,1"))>0){ $is_storno = true; }
      foreach($rg_output AS $rf_id => $rfVal){
        if($rfVal['res_id']==$res_id){
          $sum_bruto -= $rg_output[$rf_id]['price_bruto'];
          $sum_netto -= $rg_output[$rf_id]['price_netto'];
          $sum_vat -= $rg_output[$rf_id]['price_vat'];
          $sum_paid -= $rg_output[$rf_id]['price_paid'];
          $sum_paid_netto -= $rg_output[$rf_id]['price_paid_netto'];
          $sum_paid_vat -= $rg_output[$rf_id]['price_paid_vat'];
          $sum_open -= $rg_output[$rf_id]['price_open'];
          $rg_output[$rf_id]['print_color'] = 'color:blue;text-decoration: line-through;';
          $rg_output[$rf_id]['print_colornote'] = 'color:blue;';
          if(preg_match('/'.$CALTEXT['NO_STORNO_BIL'].'/',$rg_output[$rf_id]['newbil_down']) OR $rg_output[$rf_id]['newbil_down']==$CALTEXT['STORNO']){
            $rg_output[$rf_id]['newbil_down']='';
          }
          $rg_output[$rf_id]['newbil_down'] = (($rg_output[$rf_id]['newbil_down']=='' AND $allrgfiles['tpl']==5)?$CALTEXT['STORNO']:$CALTEXT['NEWBIL_DOWN']);
        }
      }
      $rfile_id = $allrgfiles['rfile_id'];
      $file = md5($rfile_id);
      $object_id = $allrgfiles['object_id'];
      $section_id = $allrgfiles['section_id'];
      $p_unit = $datapdo->get_one("SELECT `p_unit` FROM `".TABLE_PREFIX."res_price_sets` WHERE `object_id`='$object_id' LIMIT 1");
      $unit = (isset($TEXT['PRICE_UNIT'][$p_unit])?$TEXT['PRICE_UNIT'][$p_unit]:$p_unit);
      $obj_title = get_object_title($object_id);
      $modified_when = $datapdo->get_one("SELECT `modified_when` FROM `".TABLE_PREFIX."reservations` WHERE `res_id`='$res_id' LIMIT 1");
      $savedate = $allrgfiles['savedate'];
      $bil_savedate = ($savedate>0?convert_date(DATE_FORMAT,$allrgfiles['savedate']):'');
      $savedate = ($savedate > 0?$savedate:$modified_when);
      $newbilcolor = '';
      $newbildown = '';
      $bil_number = ($allrgfiles['bil_number']!=''?$allrgfiles['bil_number']:$admin->zero_to_number($res_id));
      $bil_title = $allrgfiles['title'];
      if($bil_savedate != ''){
        $datepat = "/".addslashes($bil_savedate)."/";
        if(!preg_match($datepat,$bil_title)){ $bil_title .= ' ('.$bil_savedate.')'; }
      }
      $address_id = $allrgfiles['address_id'];
      $bil_link = BC_URL.'/files/index.php?adr='.$address_id.ARGSOJS.'file='.$file;
      if($address_id>0){
        $address_company = $admin->get_company($address_id);
        $address_name = $admin->get_adr_name($address_id);
        $address_prename = $admin->get_adr_prename($address_id);
        $address_output = ($address_company != ''?$address_company.', ':'').($address_prename != ''?$address_prename.' ':'').$address_name;
        $address = $admin->get_adr_complate($address_id);
      }
      else{ $address_output = ''; }
      $bil_author = $allrgfiles['author'];
      $vats = array('B'=>array('base_price'=>0,'calcvat'=>1),'H'=>array('base_price'=>0,'calcvat'=>1),'N'=>array('base_price'=>0,'calcvat'=>1),'O'=>array('base_price'=>0,'calcvat'=>1));
      $price_bruto = 0;
      $subprice_bruto = 0;
      $price_netto = 0;
      $price_vat = 0;
      $incaddprices = 0;
      // Check first the VAT is available
      $is_resvat = true;
      if($datapdo->numRows($datapdo->query("SELECT `invoice_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `item_id` LIKE 'SEAS%' AND `vat`='B'"))>0){ $is_resvat = false; }
      // Get first the storno bil
      if($allrgfiles['tpl'] == 5){
        $price_bruto = $datapdo->get_one("SELECT `storno_price` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$res_id' LIMIT 1");
        $calcvat = 1;
        $incvatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `fix`='0' AND `item_id` LIKE 'SEAS%' LIMIT 1");
        if($incvatid==''){ $incvatid='B'; }
        $get_vatpercent = $datapdo->query("SELECT `vat_percent` FROM `".TABLE_PREFIX."billing_vat` WHERE `vat_nameid` LIKE '".$incvatid."%' AND `vat_start`<'$savedate' AND (`vat_end`='0' OR `vat_end`>'$savedate') LIMIT 0,1");
        if($is_resvat == true AND $datapdo->numRows($get_vatpercent)>0){
          $vatpercent = $datapdo->fetchRow($get_vatpercent);
          $calcvat += ($vatpercent['vat_percent'] / 100);
        }
        $vats[$incvatid]['base_price'] += $price_bruto;
        $vats[$incvatid]['calcvat'] = $calcvat;
        $curr_prices = $datapdo->get_one("SELECT `storno_price` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$res_id' LIMIT 1");
        $diffprice = $price_bruto - $curr_prices;
      }
      else{
        // Get the prices for special or no special
        $package = $datapdo->get_one("SELECT `package` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$res_id' LIMIT 1");
        if($package > 0){
          // Get first all items are included to special price
          $get_incadds = $datapdo->query("SELECT `item_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `external`='0' AND (`fix`='1' OR `item_id` LIKE 'FFLD%') AND `single_price`='0' AND (`item_id` LIKE 'ADDS%' OR `item_id` LIKE 'MORE%')");
          if($datapdo->numRows($get_incadds)>0){
            while($incadds = $datapdo->fetchRow($get_incadds)){
              $iid = $incadds['item_id'];
              $get_addsprice = $datapdo->query("SELECT (`single_price`*`quantity`) AS `price`,`vat`,`section_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `fix`='0' AND `item_id`='$iid' LIMIT 0,1");
              if($datapdo->numRows($get_addsprice)>0){
                $incaddpr = $datapdo->fetchRow($get_addsprice);
                $incprice_bruto = $incaddpr['price'];
                $incaddprices += $incprice_bruto;
              }
              $price_bruto += $incprice_bruto;
            }
          }
          $get_invoice = $datapdo->query("SELECT (`single_price`*`quantity`) AS `price`,`vat`,`item_id`,`section_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `fix`='1'");
          if($datapdo->numRows($get_invoice)>0){
            while($invoice_special = $datapdo->fetchRow($get_invoice)){
              $specialprice_bruto = $invoice_special['price'];
              $specialvatid = $invoice_special['vat'];
              $temp_bruto = $specialprice_bruto;
              $item_id_name = $invoice_special['item_id'];
              if(preg_match('/SPECIAL/',$invoice_special['item_id'])){
                $specialprice_bruto -= $incaddprices;
                $item_id_name = 'SEASON';
                $specialdet_bruto = $specialprice_bruto;
                $specialvatid = $datapdo->get_one("SELECT `vat` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `item_id` LIKE 'SEAS%' LIMIT 1");
              }
              else{
                $get_invoice_sdetail = $datapdo->query("SELECT (`single_price`*`quantity`) AS `price`,`vat`,`external` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `item_id`='$item_id_name' AND `fix`='0' LIMIT 0,1");
                if($datapdo->numRows($get_invoice_sdetail)>0){
                  $invoice_sdetails = $datapdo->fetchRow($get_invoice_sdetail);
                  $specialdet_bruto = $invoice_sdetails['price'];
                  $specialvatid = $invoice_sdetails['vat'];
                  if($invoice_sdetails['external']==1){ $subprice_bruto += $specialdet_bruto; }
                }
              }
              $calcvat = 1;
              $get_vatpercent = $datapdo->query("SELECT `vat_percent` FROM `".TABLE_PREFIX."billing_vat` WHERE `vat_nameid` LIKE '".$specialvatid."%' AND `vat_start`<'$savedate' AND (`vat_end`='0' OR `vat_end`>'$savedate') LIMIT 0,1");
              if($is_resvat == true AND $datapdo->numRows($get_vatpercent)>0){
                $vatpercent = $datapdo->fetchRow($get_vatpercent);
                $calcvat += ($vatpercent['vat_percent'] / 100);
              }
              $vats[$specialvatid]['base_price'] += $specialdet_bruto;
              $vats[$specialvatid]['calcvat'] = $calcvat;
              $price_bruto += $specialprice_bruto;
              $specialdet_netto = round(($specialdet_bruto/$calcvat),2);
              $bildetails_array[] = array('section'=>$invoice_special['section_id'],'item_id'=>$item_id_name,'single_bruto'=>$specialdet_bruto,'single_netto'=>$specialdet_netto);
            }
          }
          $curr_prices = $datapdo->get_one("SELECT `fixed_price` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$res_id' LIMIT 1");
        }
        else{
          $get_invoice = $datapdo->query("SELECT `section_id`,`single_price`,`quantity`,`vat`,`item_id`,`external` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$object_id' AND `res_id`='$res_id' AND `fix`='0'");
          if($datapdo->numRows($get_invoice)>0){
            while($invoice = $datapdo->fetchRow($get_invoice)){
              if(substr($invoice['item_id'],0,4)=='DISC'){
                $sprice_bruto = $invoice['single_price'] * (-1);
              }
              else{
                $sprice_bruto = $invoice['single_price'] * $invoice['quantity'];
              }
              $vatid = $invoice['vat'];
              // Get VAT for this id and savedate
              $calcvat = 1;
              $get_vatpercent = $datapdo->query("SELECT `vat_percent` FROM `".TABLE_PREFIX."billing_vat` WHERE `vat_nameid` LIKE '".$vatid."%' AND `vat_start`<'$savedate' AND (`vat_end`='0' OR `vat_end`>'$savedate') LIMIT 0,1");
              if($is_resvat == true AND $datapdo->numRows($get_vatpercent)>0){
                $vatpercent = $datapdo->fetchRow($get_vatpercent);
                $calcvat += ($vatpercent['vat_percent'] / 100);
              }
              if($invoice['external']==1){ $subprice_bruto += $sprice_bruto; }
              else{
                $vats[$vatid]['base_price'] += $sprice_bruto;
                $vats[$vatid]['calcvat'] = $calcvat;
                $price_bruto += $sprice_bruto;
              }
              $negativadd = ($sprice_bruto<0?-0.01:0);
              $sdet_netto = round((($sprice_bruto+$negativadd)/$calcvat),2);
              $bildetails_array[] = array('section'=>$invoice['section_id'],'item_id'=>$invoice['item_id'],'single_bruto'=>$sprice_bruto,'single_netto'=>$sdet_netto); //round(($sprice_bruto/$calcvat),2));
            }
          }
        }
      }
      if($is_storno==true){
        $pricefld = "`storno_price`";
      }
      else{
        $pricefld = ($package > 0?"`fixed_price`":"`total_price`");
      }
      $curr_prices = $datapdo->get_one("SELECT $pricefld FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$res_id' LIMIT 1");
      $corectingurl = '';
      if($savedate == 0 OR $savedate < $modified_when OR $price_bruto <> ($curr_prices-$subprice_bruto)){
//        $is_error = true;
        $savedate = $modified_when;
        $newbilcolor = 'color:red';
        $newbilcolornote = 'color:red';
        $corectingurl = '<a style="color:red;" href="'.ADMIN_URL.'/reservations/mod_sendmail.php?res_id='.$res_id.ARGSO.'back=4'.ARGSO.'tpl=';
        if($is_storno == true){
          // Check the storno is later saved
          $chkstorno = $datapdo->numRows($datapdo->query("SELECT `rfile_id` FROM `".TABLE_PREFIX."res_files` WHERE `res_id`='$res_id' AND `tpl`='5' AND `savedate`>'$savedate' LIMIT 0,1"));
          if($chkstorno>0){ $corectingurl = $CALTEXT['STORNO']; }
          else{
           $corectingurl .= '5">'.$CALTEXT['NO_STORNO_BIL'].'</a>';
          }
        }
        else{
          $corectingurl .= '3">';
          if($price_bruto <> ($curr_prices-$subprice_bruto)){ $corectingurl .= $CALTEXT['DIFFERNT_PRICE'].'</a>'; }
          else{
            $corectingurl .= $CALTEXT['MOD_AFTER_BIL'].'</a>';
          }
        }
        $newbildown = $corectingurl;
      }
      $sum_bruto += $price_bruto;
      $price_netto = 0;
      $price_vat = 0;
      $sum_vats = array('B'=>array('bruto'=>0,'netto'=>0,'calcvat'=>1),'N'=>array('bruto'=>0,'netto'=>0,'calcvat'=>1),'H'=>array('bruto'=>0,'netto'=>0,'calcvat'=>1),'O'=>array('bruto'=>0,'netto'=>0,'calcvat'=>1));
      foreach($vats AS $vID => $vP){
        $price_snetto = ($vP['base_price']/$vP['calcvat']);
        $price_netto += round($price_snetto,2,PHP_ROUND_HALF_UP);
        $sum_vats[$vID]['bruto'] += $vP['base_price'];
        $sum_vats[$vID]['netto'] += $price_snetto;
        $sum_vats[$vID]['calcvat'] = $vP['calcvat'];
      }
      $price_vat += ($price_bruto-$price_netto);
      $sum_netto += $price_netto;
      $sum_vat += $price_vat;
      $print_price_bruto = number_format($price_bruto,2,$decimal,$thousend).'&nbsp;'.$unit;
      if($price_netto == $price_bruto AND $price_vat == 0){
        $print_price_vat = '--';
      }
      else{
        $print_price_vat =  number_format($price_vat,2,$decimal,$thousend).'&nbsp;'.$unit;
      }
      $print_price_netto = number_format($price_netto,2,$decimal,$thousend).'&nbsp;'.$unit;
      $paid_price = $datapdo->get_one("SELECT `paid_price` FROM `".TABLE_PREFIX."res_price_calc` WHERE `res_id`='$res_id' LIMIT 1");
      $print_paid_price = number_format($paid_price,2,$decimal,$thousend).'&nbsp;'.$unit;
      $open_price = $price_bruto - $paid_price;
      if($open_price <> 0){
        $print_open_price = '<a href="'.ADMIN_URL.'/reservations/mod_paymant.php?object_id='.$object_id.ARGSO.'section_id='.$section_id.ARGSO.'res_id='.$res_id.ARGSO.'backlist=5" style="'.($open_price<0?'color:red;':'color:orange;').'">'.number_format($open_price,2,$decimal,$thousend).'&nbsp;'.$unit.'</a>';
      }
      else{
        $print_open_price = number_format($open_price,2,$decimal,$thousend).'&nbsp;'.$unit;
      }
      $csv_open_price = number_format($open_price,2,$decimal,$thousend).'&nbsp;'.$unit;
      $sum_paid += $paid_price;
      $temp_paid_vat = 1;
      if($price_netto>0){ $temp_paid_vat = ($price_bruto/$price_netto); }
      $paid_price_netto = ($paid_price/$temp_paid_vat);
      $paid_price_vat = $paid_price-$paid_price_netto;
      $sum_paid_netto += $paid_price_netto;
      $sum_paid_vat += $paid_price_vat;
      $sum_open += $open_price;
      $rg_output[$rfile_id] = array('object_id'=>$object_id,'obj_title'=>$obj_title,'res_id'=>$res_id,'bil_number'=>$bil_number,'bil_savedate'=>$bil_savedate,
				  'bil_link'=>$bil_link,'bil_title'=>$bil_title,'bil_author'=>$bil_author,'address_output'=>$address_output,'address'=>$address,
				  'price_bruto'=>$price_bruto,'price_netto'=>$price_netto,'price_vat'=>$price_vat,'price_paid'=>$paid_price,'price_open'=>$open_price,'details'=>$bildetails_array,
				  'price_paid_netto'=>$paid_price_netto,'price_paid_vat'=>$paid_price_vat,'newbil_down'=>$newbildown,'opencolor'=>($open_price<0?'color:red;':''),
				  'print_price_bruto'=>$print_price_bruto,'print_price_netto'=>$print_price_netto,'print_price_vat'=>$print_price_vat,
				  'print_price_paid'=>$print_paid_price,'print_price_open'=>$print_open_price,'csv_open_price'=>$csv_open_price,'print_color'=>$newbilcolor,'print_colornote'=>$newbilcolornote);
    }
  }
  $output .= '<h3>'.$TEXT['BILS'].' '.$TEXT['TO'].' '.$TEXT['GUESTS'].'</h3>'."\n";
  $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['BILS'].' '.$TEXT['TO'].' '.$TEXT['GUESTS'],$local_charset).$csv_seperator2.$csv_seperator."\n";
  $is_error = false;
  $is_error2 = false;
  if(count($rg_output)>0){
    $output .= '<table width="100%" border="0" cellspacing="0" cellpadding="2">'."\n";
    $output .= '<tr>'."\n";
    $output .= '  <th style="width:8%;text-align:left;">'.$TEXT['DATE'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['DATE'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:9%;text-align:left;">'.$TEXT['BIL'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['BIL'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:15%;text-align:left;">'.$TEXT['ADDRESS'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['ADDRESS'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:15%;text-align:left;">'.$TEXT['OBJECT'].' ('.$TEXT['RESERVATION'].')</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['OBJECT'].' ('.$TEXT['RESERVATION'].')',$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:9%;text-align:right;">'.$CALTEXT['PRICE_NETTO'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($CALTEXT['PRICE_NETTO'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:7%;text-align:right;">'.$TEXT['VAT_SHORT'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['VAT_SHORT'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:9%;text-align:right;">'.$TEXT['CALCULATED'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['CALCULATED'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:9%;text-align:right;">'.$CALTEXT['PAIDPRICE'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($CALTEXT['PAIDPRICE'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:9%;text-align:right;">'.$CALTEXT['OPENPRICE'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($CALTEXT['OPENPRICE'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="width:10%;text-align:center;">'.$TEXT['NOTICE'].'</th>'."\n";
    $output .= '</tr>'."\n";
    $csv_output .= "\n";
    $row = 'a';
    $csv_sum_vat = 0;
    $csv_sum_bruto = 0;
    $csv_sum_netto = 0;
    $csv_sum_paid = 0;
    $csv_sum_open = 0;
    foreach($rg_output AS $rgId => $rgVal){
      if(preg_match('/red/',$rgVal['print_colornote']) AND $rgVal['newbil_down']!='' AND $is_error==false){
        $is_error = ($rgVal['newbil_down']==$CALTEXT['STORNO']?false:true);
        $is_error2 = ($rgVal['newbil_down']==$CALTEXT['STORNO']?true:false);
      }
      elseif(!preg_match('/blue/',$rgVal['print_colornote'])){
        $paid_bruto = $rgVal['price_paid'];
        $price_bruto = $rgVal['price_bruto'];
        $price_netto = $rgVal['price_netto'];
        if($price_netto > 0){
          $vatcalc = $price_bruto/$price_netto;
          $paid_netto = $rgVal['price_paid']/$vatcalc;
        }
        else{
          $vatcalc = 1;
          $paid_netto = $rgVal['price_paid'];
        }
        $paid_vat = $rgVal['price_paid'] - $paid_netto;
//        $sales_totalsum[$rgVal['res_id']] = array('bruto'=>$rgVal['price_bruto'],'netto'=>$rgVal['price_netto'],'vat'=>$vatcalc,'paid_netto'=>$paid_netto,'paid_vat'=>$paid_vat,'paid_bruto'=>$paid_bruto);
      }
      $output .= '<tr class="row_'.$row.'">'."\n";
      $output .= '  <td>'.$rgVal['bil_savedate'].'</td>'."\n";
      $output .= '  <td><a href="#fullrg'.$rgVal['bil_number'].'" onmouseover="$(\'#fullrg'.$rgId.'\').show();" onmouseout="$(\'#fullrg'.$rgId.'\').hide();" onclick="openWin(\''.$rgVal['bil_link'].'\',\''.$rgVal['bil_title'].'\',\''.$TEXT['BIL'].'\');">'.$rgVal['bil_number'].'</a>'."\n";
      $output .= '  <div id="fullrg'.$rgId.'" class="formInfoBox">'.$rgVal['bil_number'].'<br />'.$rgVal['bil_title'].'</div>'."\n";
      $output .= '  </td>'."\n";
      $output .= '  <td>'."\n";
      if($rgVal['address_output']!=''){
        $output .= '  <a href="#" onmouseover="$(\'#fulladr'.$rgId.'\').show();" onmouseout="$(\'#fulladr'.$rgId.'\').hide();">'.$rgVal['address_output'].'</a>';
        $output .= '  <div id="fulladr'.$rgId.'" class="formInfoBox">'.$rgVal['address'].'</div>'."\n";
        $csv_full_address = str_replace(array('<br />','&amp;','&','&quot;','"'),array(', ','&','&','',''),$rgVal['address_output']);
        $csv_output_adr = $csv_seperator2.entities_to_umlauts($csv_full_address,$local_charset).$csv_seperator2.$csv_seperator;
      }
      else{
        $output .= '&nbsp;';
        $csv_output_adr = $csv_seperator2.$csv_seperator2.$csv_seperator;
      }
      $output .= '  </td>'."\n";
      $output .= '  <td style="'.$rgVal['print_color'].';vertical-align:top;"><a name="fullrg'.$rgVal['bil_number'].'"></a>'.$rgVal['obj_title'].' ('.$admin->zero_to_number($rgVal['res_id']).')</td>'."\n";
      $output .= '  <td style="text-align:right;'.$rgVal['print_color'].'">'.$rgVal['print_price_netto'].'</td>'."\n";
      $output .= '  <td style="text-align:right;'.$rgVal['print_color'].'">'.$rgVal['print_price_vat'].'</td>'."\n";
      $output .= '  <td style="text-align:right;'.$rgVal['print_color'].'">'.$rgVal['print_price_bruto'].'</td>'."\n";
      $output .= '  <td style="text-align:right;'.$rgVal['print_color'].'">'.$rgVal['print_price_paid'].'</td>'."\n";
      $output .= '  <td style="text-align:right;'.$rgVal['print_color'].''.$rgVal['opencolor'].'">'.$rgVal['print_price_open'].'</td>'."\n";
      $output .= '  <td style="text-align:center;'.$rgVal['print_colornote'].'">'.$rgVal['newbil_down'].'</td>'."\n";
      if($rgVal['newbil_down']=='' OR preg_match('/red/',$rgVal['print_colornote'])){
        $csv_output .= $csv_seperator2.entities_to_umlauts($rgVal['bil_savedate'],$local_charset).$csv_seperator2.$csv_seperator;
        $csv_price_netto = preg_replace('/\&nbsp\;/',' ',$rgVal['print_price_netto']);
        $csv_output .= $csv_seperator2.entities_to_umlauts($rgVal['bil_number'].' - '.$rgVal['bil_title'],$local_charset).$csv_seperator2.$csv_seperator;
        $csv_output .= $csv_output_adr;
        $csv_sum_vat += $rgVal['price_vat'];
        $csv_sum_bruto += $rgVal['price_bruto'];
        $csv_sum_netto += $rgVal['price_netto'];
        $csv_sum_paid += $rgVal['price_paid'];
        $csv_sum_open += $rgVal['price_open'];
        if($price_netto > 0){
          $vatcalc = $price_bruto/$price_netto;
          $csv_paid_netto = $rgVal['price_paid']/$vatcalc;
        }
        else{
          $vatcalc = 1;
          $csv_paid_netto = $rgVal['price_paid'];
        }

        $csv_price_vat = preg_replace('/\&nbsp\;/',' ',$rgVal['print_price_vat']);
        $csv_price_bruto = preg_replace('/\&nbsp\;/',' ',$rgVal['print_price_bruto']);
        $csv_price_paid = preg_replace('/\&nbsp\;/',' ',$rgVal['print_price_paid']);
        $csv_price_open = preg_replace('/\&nbsp\;/',' ',$rgVal['csv_open_price']);

        $csv_output .= $csv_seperator2.entities_to_umlauts($rgVal['bil_number'].$rgVal['obj_title'].' ('.$admin->zero_to_number($rgVal['res_id']).')',$local_charset).$csv_seperator2.$csv_seperator;
        $csv_output .= $csv_seperator2.entities_to_umlauts($csv_price_netto,$local_charset).$csv_seperator2.$csv_seperator;
        $csv_output .= $csv_seperator2.entities_to_umlauts($csv_price_vat,$local_charset).$csv_seperator2.$csv_seperator;
        $csv_output .= $csv_seperator2.entities_to_umlauts($csv_price_bruto,$local_charset).$csv_seperator2.$csv_seperator;
        $csv_output .= $csv_seperator2.entities_to_umlauts($csv_price_paid,$local_charset).$csv_seperator2.$csv_seperator;
        $csv_output .= $csv_seperator2.entities_to_umlauts($csv_price_open,$local_charset).$csv_seperator2.$csv_seperator;
        $csv_output .= "\n";
      }
      $output .= '</tr>'."\n";
      $output_details = '';
      if(count($rgVal['details'])>0 AND $rgVal['newbil_down']==''){
        foreach($rgVal['details'] AS $line => $detarray){
          if($detarray['single_bruto']<>0){
            if(preg_match('/SEASON/',$detarray['item_id'])){ $detout_title = $CALTEXT['RENT']; }
            else{
              $item_id_split = explode('_',$detarray['item_id']);
              if($item_id_split[0]=='DISC'){ $detout_title = $CALTEXT['DISCOUNT_TYPE_'.$item_id_split[1]]; }
              else{
                $detout_title = get_name_addkey($item_id_split[1],strtolower($item_id_split[0]),$detarray['section']);
              }
            }
            $print_detbruto = number_format($detarray['single_bruto'],2,$decimal,$thousend).'&nbsp;'.$unit;
            $print_detnetto = number_format($detarray['single_netto'],2,$decimal,$thousend).'&nbsp;'.$unit;
            $print_detvat = number_format(($detarray['single_bruto']-$detarray['single_netto']),2,$decimal,$thousend).'&nbsp;'.$unit;
            $csv_detbruto = number_format($detarray['single_bruto'],2,$decimal,$thousend).' '.$unit;
            $csv_detnetto = number_format($detarray['single_netto'],2,$decimal,$thousend).' '.$unit;
            $csv_detvat = number_format(($detarray['single_bruto']-$detarray['single_netto']),2,$decimal,$thousend).' '.$unit;
            $output_details .= '<tr class="row_'.$row.'"><td colspan="3" style="text-align:center">'.($output_details==''?$TEXT['VIEW_DETAILS']:'').'</td>';
            $output_details .= '<td>'.$detout_title.'</td><td style="text-align:right;">'.$print_detnetto.'</td><td style="text-align:right;">'.$print_detvat.'</td><td style="text-align:right;">'.$print_detbruto.'</td><td colspan="3">&nbsp;</td>';
            $output_details .= '</tr>';
            $csv_output .= $csv_seperator2.$csv_seperator2.$csv_seperator.$csv_seperator2.$csv_seperator2.$csv_seperator;
            $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['VIEW_DETAILS'],$local_charset).$csv_seperator2.$csv_seperator;
            $csv_output .= $csv_seperator2.entities_to_umlauts($detout_title,$local_charset).$csv_seperator2.$csv_seperator;
            $csv_output .= $csv_seperator2.entities_to_umlauts($csv_detnetto,$local_charset).$csv_seperator2.$csv_seperator;
            $csv_output .= $csv_seperator2.entities_to_umlauts($csv_detvat,$local_charset).$csv_seperator2.$csv_seperator;
            $csv_output .= $csv_seperator2.entities_to_umlauts($csv_detbruto,$local_charset).$csv_seperator2.$csv_seperator;
            $csv_output .= "\n";
          }
        }
      }
      $output .= $output_details;
      $row = ($row=='a'?'b':'a');
    }
    $csv_tmp_vat = $csv_sum_bruto/$csv_sum_netto;
    $csv_sum_paid_netto = $csv_sum_paid/$csv_tmp_vat;
    $sales_totalsum[] = array('paid_bruto'=>$csv_sum_paid,'paid_netto'=>$csv_sum_paid_netto,'paid_vat'=>($csv_sum_paid-$csv_sum_paid_netto));

    $output .= '<tr style="border-top:1px solid #555555;">'."\n";
    $output .= '  <th colspan="4" style="text-align:right;">'.$CALTEXT['SUMM_FROM_BILS'].':</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($CALTEXT['SUMM_FROM_BILS'],$local_charset).$csv_seperator2.$csv_seperator;
    $csv_output .= $csv_seperator2.$csv_seperator2.$csv_seperator;
    $csv_output .= $csv_seperator2.$csv_seperator2.$csv_seperator;
    $csv_output .= $csv_seperator2.$csv_seperator2.$csv_seperator;
    $output .= '  <th style="text-align:right;">'.number_format($csv_sum_netto,2,$decimal,$thousend).'&nbsp;'.$unit.'</th>'."\n";
    $csv_output .= $csv_seperator2.number_format($csv_sum_netto,2,$decimal,$thousend).entities_to_umlauts(' '.$unit,$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="text-align:right;">'.number_format($csv_sum_vat,2,$decimal,$thousend).'&nbsp;'.$unit.'</th>'."\n";
    $csv_output .= $csv_seperator2.number_format($csv_sum_vat,2,$decimal,$thousend).entities_to_umlauts(' '.$unit,$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="text-align:right;">'.number_format($csv_sum_bruto,2,$decimal,$thousend).'&nbsp;'.$unit.'</th>'."\n";
    $csv_output .= $csv_seperator2.number_format($csv_sum_bruto,2,$decimal,$thousend).entities_to_umlauts(' '.$unit,$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="text-align:right;">'.number_format($csv_sum_paid,2,$decimal,$thousend).'&nbsp;'.$unit.'</th>'."\n";
    $csv_output .= $csv_seperator2.number_format($csv_sum_paid,2,$decimal,$thousend).entities_to_umlauts(' '.$unit,$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="text-align:right;">'.number_format($csv_sum_open,2,$decimal,$thousend).'&nbsp;'.$unit.'</th>'."\n";
    $csv_output .= $csv_seperator2.number_format($csv_sum_open,2,$decimal,$thousend).entities_to_umlauts(' '.$unit,$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th style="text-align:center;">&nbsp;</th>'."\n";
    $output .= '</tr>'."\n";
    $csv_output .= "\n";

    $output .= '</table>'."\n";
  }
  else{  $output .= '<p>'.$TEXT['NONE_FOUND'].'</p>'; }
  if($is_error == true){ $output .= '<p style="color:red;"><strong>'.$CALTEXT['PRICE_ERRORS'].'</strong></p>'."\n"; }
  if($is_error2 == true){ $output .= '<p style="color:red;"><strong>'.$CALTEXT['STORNO_LATER'].'</strong></p>'."\n"; }
}
$prov_paid_info = '';
$bil_object_ids = array();
if($is_resbilling==true AND $show_prov==true){
  $bilsql = '';
  if($dsql != ''){
    $bilsql = preg_replace('/savedate/','bil_date',$dsql);
  }
  $bilmandsql = '';
  if(!empty($filter_objsql)){
    $get_mandants = $datapdo->query("SELECT `object_id`,`mandant_id` FROM `".TABLE_PREFIX."resbilling_objset` WHERE `last_modified`>'0'".$filter_objsql);
    $countmandants = $datapdo->numRows($get_mandants);
    $count_outmandant = 0;
    $m_mandid = 0;
    if($countmandants > 0){
      while($mandants = $datapdo->fetchRow($get_mandants)){
        $mand_id = $mandants['mandant_id'];
        if($mand_id != $m_mandid){
          $count_outmandant++;
          $m_mandid = $mand_id;
        }
        $bilmandsql .= ($bilmandsql==''?" AND (":" OR ")."`mandant_id`='".$mand_id."'";
        $mandant = $admin->get_adr_complate($mand_id);
        $bil_object_ids[$mand_id][] = $mandants['object_id'];
      }
      $bilmandsql .= ")";
    }
  }
  $bilsql .= $bilmandsql;

  // Get all privisions like date
  $get_resbillings = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."resbilling` WHERE `total_commission`>'0'".$bilsql." ORDER BY `bil_date` ASC");
  if($datapdo->numRows($get_resbillings)>0){
    $prov_paid_info = $CALTEXT['PROV_ARE_ALL_PAID'];
    $output .= '<h3'.($show_rg==true?' style="page-break-before:always;"':'').'>'.$TEXT['RESBILLINGS'].'</h3>'."\n";
    $csv_output .= "\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['RESBILLINGS'],$local_charset).$csv_seperator2.$csv_seperator."\n";
    if($count_outmandant == 1){
      $output .= '  <p style="text-align:left;">'.$mandant.'</p>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts($mandant,$local_charset).$csv_seperator2.$csv_seperator.'\n';
    }
    if(count($bil_object_ids[$mand_id])==1){
      $output .= '<p style="text-align:left;font-weight:bold">'.get_object_title($bil_object_ids[$mand_id][0]).'</p>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts(get_object_title($bil_object_ids[$mand_id][0]),$local_charset).$csv_seperator2.$csv_seperator.'\n';
    }
    $output .= '<table width="100%" border="0" cellspacing="0" cellpadding="2">'."\n";
    $output .= '<tr>'."\n";
    $output .= '  <th width="10%" align="left">'.$TEXT['DATE'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['DATE'],$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '  <th width="'.(($count_outmandant > 1 OR ($count_outmandant == 1 AND $bil_object_ids[$mand_id]>1))?'15%':'35%').'" align="left">'.$TEXT['BIL'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['BIL'],$local_charset).$csv_seperator2.$csv_seperator;
    if($count_outmandant > 1){
      $output .= '  <th width="20%" align="left">'.$TEXT['ADDRESS'].'</th>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['ADDRESS'],$local_charset).$csv_seperator2.$csv_seperator;
    }
    elseif($count_outmandant == 1 AND count($bil_object_ids[$mand_id])>1){
      $output .= '  <th width="20%" align="left">'.$TEXT['OBJECT'].'</th>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['OBJECT'],$local_charset).$csv_seperator2.$csv_seperator;
    }
    $output .= '  <th width="10%" align="right">'.$CALTEXT['PRICE_NETTO'].'</th>'."\n";
    $csv_output .= $csv_seperator2.$CALTEXT['PRICE_NETTO'].$csv_seperator2.$csv_seperator;
    $output .= '  <th width="10%" align="right">'.$TEXT['VAT_SHORT'].'</th>'."\n";
    $csv_output .= $csv_seperator2.$TEXT['VAT_SHORT'].$csv_seperator2.$csv_seperator;
    $output .= '  <th width="10%" align="right">'.$TEXT['CALCULATED'].'</th>'."\n";
    $csv_output .= $csv_seperator2.$TEXT['CALCULATED'].$csv_seperator2.$csv_seperator;
    $output .= '  <th width="25%" align="center">'.$TEXT['NOTICE'].'</th>'."\n";
    $output .= '</tr>'."\n";
    $csv_output .= "\n";
    $row = 'a';
    $sum_com_netto = 0;
    $sum_com_vat = 0;
    $sum_amount = 0;
    $bilobjecttitle_array = array();
    while($resbillings = $datapdo->fetchRow($get_resbillings,false)){
//      $curr_object = true;
      $billing_id = $resbillings['billing_id'];
      $bil_number = $resbillings['bil_number'];
      $bil_date = convert_date(DATE_FORMAT,$resbillings['bil_date']);
      $bil_title = $TEXT['RESBILLING'];
      $mandant_id = $resbillings['mandant_id'];
      // Check the object is selected
      $get_mandantoid = $datapdo->query("SELECT `object_id`,`mandant_id` FROM `".TABLE_PREFIX."resbilling_objset` WHERE `mandant_id`='$mandant_id'".$filter_objsql);
      while($mandantoid = $datapdo->fetchRow($get_mandantoid)){
        $chkoid = $mandantoid['object_id'];
        if(!is_numeric(array_search($chkoid,$bil_object_ids[$mand_id]))){ continue 1; } //$curr_object = false; }
        else{
          $get_objects_rfid = $datapdo->query("SELECT `billing_id`,`object_id` FROM `".TABLE_PREFIX."resbilling_detail` WHERE `billing_id`='$billing_id'");
          $m_bID = 0;
          $m_oT = array();
          $bilobjecttitle_array[$billing_id] = '';
          while($objects_rfid = $datapdo->fetchRow($get_objects_rfid)){
            if($m_bID != $objects_rfid['billing_id']){
              $m_bID = $objects_rfid['billing_id'];
              array_push($m_oT,$objects_rfid['object_id']);
            }
          }
          $bilobjecttitle_array[$billing_id] = $m_oT;
        }
      }
      // Get the unit from settings
      $getunit = $datapdo->get_one("SELECT `commission_unit` FROM `".TABLE_PREFIX."resbilling_objset` WHERE `mandant_id`='$mandant_id' LIMIT 1");
      $prov_unit = (isset($TEXT['PRICE_UNIT'][$getunit])?$TEXT['PRICE_UNIT'][$getunit]:$getunit);
      $unit = ((!isset($unit) OR $unit=='')?$prov_unit:$unit);
      $mandant_company = $admin->get_company($mandant_id);
      $mandant_name = $admin->get_adr_name($mandant_id);
      $mandant_prename = $admin->get_adr_prename($mandant_id);
      $mandant_output = ($mandant_company != ''?$mandant_company.', ':'').($mandant_prename != ''?$mandant_prename.' ':'').$mandant_name;
      $mandant = $admin->get_adr_complate($mandant_id);
      $total_com = $resbillings['total_commission'];
      $total_vat = $resbillings['commission_vat'];
      $total_amount = $resbillings['bil_amount'];
      $sum_com_netto += $total_com;
      $sum_com_vat += $total_vat;
      $output .= '<tr class="row_'.$row.'">'."\n";
      $output .= '<td align="left">'.$bil_date.'</td>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts($bil_date,$local_charset).$csv_seperator2.$csv_seperator;
      $output .= '<td align="left"><a href="#provrg'.$billing_id.'" onmouseover="$(\'#provrg'.$billing_id.'\').show();" onmouseout="$(\'#provrg'.$billing_id.'\').hide();" onclick="openWin(\''.ADMIN_URL.'/resbilling/resbilprint.php?bil='.$billing_id.'&storno=0\',\''.$MENU['RESBILLING'].'\');">'.$bil_number.'</a>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts($bil_number.chr(10).$bil_title,$local_charset).$csv_seperator2.$csv_seperator;
      $output .= '  <div id="provrg'.$billing_id.'" class="formInfoBox" style="text-align:left;">'.$bil_number.'<br />'.$bil_title.'</div></td>'."\n";
      if($count_outmandant > 1){
        $output .= '<td align="left"><a href="#provrg'.$billing_id.'" onmouseover="$(\'#provadr'.$billing_id.'\').show();" onmouseout="$(\'#provadr'.$billing_id.'\').hide();">'.$mandant_output.'</a>'."\n";
        $csv_output .= $csv_seperator2.entities_to_umlauts($mandant,$local_charset).$csv_seperator2.$csv_seperator;
        $output .= '  <div id="provadr'.$billing_id.'" class="formInfoBox" style="text-align:left;">'.$mandant.'</div>'."\n";
        $output .= '</td>'."\n";
      }
      elseif($count_outmandant == 1 AND count($bil_object_ids[$mand_id])>1){
        $output .= '<td align="left">'."\n";
        $bilobjecttitle = '';
        foreach($bilobjecttitle_array[$billing_id] AS $oKey){
          $objTitle = get_object_title($oKey);
          $bilobjecttitle .= ($bilobjecttitle!=''?',<br />':'').$objTitle;
        }
        $output .= $bilobjecttitle;
        $bilobjecttitle_csv = preg_replace('/\<br \/\>/',' ',$bilobjecttitle);
        $csv_output .= $csv_seperator2.entities_to_umlauts($bilobjecttitle_csv,$local_charset).$csv_seperator2.$csv_seperator;
        $output .= '</td>'."\n";
      }
      $output .= '<td align="right">'.number_format($total_com,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</td>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($total_com,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
      $output .= '<td align="right">'.number_format($total_vat,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</td>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($total_vat,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
      $output .= '<td align="right">'.number_format($total_amount,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</td>'."\n";
      $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($total_amount,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
      // Check is storno
      $noticetext = '';
      $get_storno = $datapdo->numRows($datapdo->query("SELECT `res_id` FROM `".TABLE_PREFIX."resbilling_detail` WHERE `billing_id`='$billing_id' AND `res_id`>'0' AND `deleted`='1'"));
      $get_alldetails = $datapdo->query("SELECT `res_id`,`transferprice`,`commissionbase`,`deleted` FROM `".TABLE_PREFIX."resbilling_detail` WHERE `billing_id`='$billing_id'");
      $get_all = $datapdo->numRows($get_alldetails);
      if($get_storno > 0){
        $noticetext = ($get_storno == $get_all?$CALTEXT['FULLBILLING_STORNO']:$CALTEXT['PARTBILLING_STORNO']);
      }
      $output .= '<td align="center">'.$noticetext.'</td>'."\n";
      $output .= '</tr>'."\n";
      $csv_output .= "\n";
      $sum_amount += $resbillings['bil_amount'];
      if($get_storno > 0){
        $get_sbilling = $datapdo->query("SELECT `sbilling_id` FROM `".TABLE_PREFIX."resbilling_sdetail` WHERE `old_number`='$bil_number'"); // LIMIT 1");
        $sbilling_merk = 0;
        while($sbilling = $datapdo->fetchRow($get_sbilling)){
          $sbilling_id = $sbilling['sbilling_id'];
          $sbil_title = $TEXT['RESBILLING_STORNO'];
          if($sbilling_id == $sbilling_merk){ continue 1; }
          $sbilling_merk = $sbilling_id;
          $get_storno = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."resbilling_storno` WHERE `sbilling_id`='$sbilling_id' LIMIT 0,1");
          if($datapdo->numRows()>0){
            $storno = $datapdo->fetchRow($get_storno,false);
            $sbil_id = $storno['sbilling_id'];
            $sbil_date = convert_date(DATE_FORMAT,$storno['bil_date']);
            $sbil_number = $storno['bil_number'];
            $sbil_total_com = $storno['storno_commission'];
            $sbil_total_vat = $storno['commission_vat'];
            $sbil_amount = $storno['bil_amount'];
            $sum_com_netto += $sbil_total_com;
            $sum_com_vat += $sbil_total_vat;
            $output .= '<tr class="row_'.$row.'">'."\n";
            $output .= '<td align="right">'.$sbil_date.'</td>'."\n";
            $csv_output .= $csv_seperator2.entities_to_umlauts($sbil_date,$local_charset).$csv_seperator2.$csv_seperator;
            $output .= '<td align="center"><a href="#sprovrg'.$sbil_id.'" onmouseover="$(\'#sprovrg'.$sbil_id.'\').show();" onmouseout="$(\'#sprovrg'.$sbil_id.'\').hide();" onclick="openWin(\''.ADMIN_URL.'/resbilling/resbilprint.php?bil='.$sbil_id.'&storno=1\',\''.$TEXT['RESBILLING_STORNO_SHORT'].'\');">'.$sbil_number.'</a>'."\n";
            $output .= '  <div id="sprovrg'.$sbil_id.'" class="formInfoBox" style="text-align:left;">'.$sbil_number.'<br />'.$sbil_title.'</div></td>'."\n";
            $csv_output .= $csv_seperator2.entities_to_umlauts($sbil_number.chr(10).$sbil_title,$local_charset).$csv_seperator2.$csv_seperator;
            if($countmandants > 1){
              $output .= '<td align="left">&nbsp;</td>'."\n";
              $csv_output .= $csv_seperator2.$csv_seperator2.$csv_seperator;
            }
            $output .= '<td align="right">'.number_format($sbil_total_com,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</td>'."\n";
            $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($sbil_total_com,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
            $output .= '<td align="right">'.number_format($sbil_total_vat,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</td>'."\n";
            $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($sbil_total_vat,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
            $output .= '<td align="right">'.number_format($sbil_amount,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</td>'."\n";
            $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($sbil_amount,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
            $output .= '<td align="center">&nbsp;</td>'."\n";
            $output .= '</tr>'."\n";
            $csv_output .= "\n";
            $sum_amount += $storno['bil_amount'];
          }
        }
      }
      $row = ($row=='a'?'b':'a');
    }
    $output .= '<tr>'."\n";
    $output .= '<th style="text-align:right;" colspan="'.($countmandants > 1?'3':'2').'">'.$CALTEXT['SUMM_FROM_PROV'].'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts($CALTEXT['SUMM_FROM_PROV'],$local_charset).$csv_seperator2.$csv_seperator;
    if($countmandants > 1){
      $csv_output .= $csv_seperator2.$csv_seperator2.$csv_seperator;
    }
    $csv_output .= $csv_seperator2.$csv_seperator2.$csv_seperator;
    $output .= '<th style="text-align:right;">'.number_format($sum_com_netto,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($sum_com_netto,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '<th style="text-align:right;">'.number_format($sum_com_vat,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($sum_com_vat,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '<th style="text-align:right;">'.number_format($sum_amount,2,$decimal,$thousend).'&nbsp;'.$prov_unit.'</th>'."\n";
    $csv_output .= $csv_seperator2.entities_to_umlauts(number_format($sum_amount,2,$decimal,$thousend).' '.$prov_unit,$local_charset).$csv_seperator2.$csv_seperator;
    $output .= '<th style="text-align:center;">&nbsp;</th>'."\n";
    $output .= '</tr>'."\n";
    $csv_output .= "\n";
    $output .= '</table>'."\n";
    $sum_com_bruto = $sum_com_netto+$sum_com_vat;
    $sales_totalsum[] = array('paid_bruto'=>$sum_com_bruto,'paid_netto'=>$sum_com_netto,'paid_vat'=>$sum_com_vat);
  }
}

//Output the sales volumes
$output .= '<h3 style="page-break-before:always;">'.$CALTEXT['SUMM_SALES'].($is_error==true?' ('.$CALTEXT['SALES_ERROR'].')':'').'</h3>'."\n";
$csv_output .= "\n";
$csv_output .= $csv_seperator2.entities_to_umlauts($CALTEXT['SUMM_SALES'].($is_error==true?' ('.$CALTEXT['SALES_ERROR'].')':''),$local_charset).$csv_seperator2.$csv_seperator;
$csv_output .= "\n";
$csv_output .= "\n";
$salestotal_bruto = 0;
$salestotal_netto = 0;
$salestotal_vat = 0;
foreach($sales_totalsum AS $rID => $rVals){
  $salescalc_bruto = $rVals['paid_bruto']; //-$rVals['open'];
  $salescalc_netto = $rVals['paid_netto']; //-($rVals['open']/$rVals['vatcalc']);
  $salescalc_vat = $rVals['paid_vat']; //$salescalc_bruto-$salescalc_netto;
  $salestotal_bruto += $salescalc_bruto;
  $salestotal_netto += $salescalc_netto;
  $salestotal_vat += $salescalc_vat;
}
$output .= '<table width="100%" border="0" cellspacing="0" cellpadding="2">'."\n";
$output .= '<tr><td width="15%">Umsatz:</td><td width="15%" align="right">'.number_format($salestotal_netto,2,$decimal,$thousend).'&nbsp;'.$unit.'</td><td rowspan="3" style="width:70%;vertical-align:top;padding-left:50px;">'.$prov_paid_info.'</td></tr>'."\n";
$csv_output .= $csv_seperator2.'Umsatz:'.$csv_seperator2.$csv_seperator;
$csv_output .= $csv_seperator2.entities_to_umlauts(number_format($salestotal_netto,2,$decimal,$thousend).' '.$unit,$local_charset).$csv_seperator2.$csv_seperator;
$csv_output .= "\n";
$output .= '<tr><td width="15%">'.$TEXT['VAT'].':'.'</td><td width="15%" align="right">'.number_format($salestotal_vat,2,$decimal,$thousend).'&nbsp;'.$unit.'</td></tr>'."\n";
$csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['VAT'].':',$local_charset).$csv_seperator2.$csv_seperator;
$csv_output .= $csv_seperator2.entities_to_umlauts(number_format($salestotal_vat,2,$decimal,$thousend).' '.$unit,$local_charset).$csv_seperator2.$csv_seperator;
$csv_output .= "\n";
$output .= '<tr><td width="15%">'.$TEXT['TOTAL_DEBIT'].':</td><td width="15%" align="right">'.number_format($salestotal_bruto,2,$decimal,$thousend).'&nbsp;'.$unit.'</td></tr>'."\n";
$csv_output .= $csv_seperator2.entities_to_umlauts($TEXT['TOTAL_DEBIT'].':',$local_charset).$csv_seperator2.$csv_seperator;
$csv_output .= $csv_seperator2.entities_to_umlauts(number_format($salestotal_bruto,2,$decimal,$thousend).' '.$unit,$local_charset).$csv_seperator2.$csv_seperator;
$csv_output .= "\n";
$output .= '</table>'."\n";
$canprint = true;
if($output != ''){
  echo $output;
}
else{
  echo $TEXT['NONE_FOUND'];
  $canprint = false;
}
$temp = BC_PATH.'/temp/';
$file = 'financ'.time();
$csv_outfilesave = $temp.$file.'.csv';
$csv_outfile = str_replace(BC_PATH,BC_URL,$csv_outfilesave);
if($canprint == true){
  $outputprint = preg_replace('#<a[^>]+href=[^>]*>(.+)<\/a>#isU','$1',$output);
  $outputprint = preg_replace('#<div[^>]*>(.+)<\/div>#i','',$outputprint);
  $outbiltitle = '<style>td,th{font-size:85%;}</style><h2>'.$MENU['FINANCES'].' - '.$CALTEXT['BILBOOK'].'</h2>';
  $outtitleprint = entities_to_umlauts($MENU['FINANCES']);
  $temp = BC_PATH.'/temp/';
  $file = 'bilfinanc'.time();

  if(file_exists(BC_PATH.'/lib/include/html2pdf/html2pdf_func.php')){
    include_once(BC_PATH.'/lib/include/html2pdf/html2pdf_func.php');
    $outfile = built_pdf_file($outbiltitle.$outputprint,$temp,$file.'.pdf',$outtitleprint,'','F','L',false,false,true,'',2);
  }
  else{
    $outfile = $temp.$file.'.html';
    $htmlhead = '<html><head><title>'.$outtitle.'</title>'."\n";
    $htmlhead .= '<meta http-equiv="Content-Type" content="text/html; charset='.(defined('DEFAULT_CHARSET')?DEFAULT_CHARSET:'utf-8').'" />'."\n";
    $htmlhead .= '<meta http-equiv="content-language" content="'.strtolower(LANGUAGE).'" />'."\n";
    $htmlhead .= '</head><body><p style="text-align:right;"><input type="button" value="'.$TEXT['PRINT'].'" onclick="javascript:window.print();" /></p>'."\n";
    $outputtofile = $htmlhead.$outbiltitle.$outputprint.'</body></html>';
    $fp = fopen($outfile,'w');
    fwrite($fp,$outputtofile);
    fclose($fp);
  }
  $outfile = str_replace(BC_PATH,BC_URL,$outfile);
  $csv_output = preg_replace('/\\x3f/', '', $csv_output);
  $csvsave = fopen($csv_outfilesave,'w');
  fwrite($csvsave,$csv_output);
  fclose($csvsave);
}
?>